org.eclipse.swt.widgets

## Class TreeColumn

- java.lang.Object
- - org.eclipse.swt.widgets.Widget
  - - org.eclipse.swt.widgets.Item
    - - org.eclipse.swt.widgets.TreeColumn

All Implemented Interfaces:
  Adaptable

    public class TreeColumn
    extends Item

Instances of this class represent a column in a tree widget.

Styles:
  LEFT, RIGHT, CENTER
Events:
  Move, Resize, Selection

Note: Only one of the styles LEFT, RIGHT and CENTER may be specified.

IMPORTANT: This class is not intended to be subclassed.

Since:
  1.0

### Constructor Summary

Constructors
Constructor and Description
`TreeColumn(Tree parent, int style)` Constructs a new instance of this class given its parent (which must be a `Tree`) and a style value describing its behavior and appearance.
`TreeColumn(Tree parent, int style, int index)` Constructs a new instance of this class given its parent (which must be a `Tree`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

### Method Summary

Methods
`void` `addControlListener(ControlListener listener)` Adds the listener to the collection of listeners who will be notified when the control is moved or resized, by sending it one of the messages defined in the `ControlListener` interface.
`void` `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the control is selected by the user, by sending it one of the messages defined in the `SelectionListener` interface.
`<T> T` `getAdapter(java.lang.Class<T> adapter)` Implementation of the `Adaptable` interface.
`int` `getAlignment()` Returns a value which describes the position of the text or image in the receiver.
`boolean` `getMoveable()` Gets the moveable attribute.
`Tree` `getParent()` Returns the receiver's parent, which must be a `Tree`.
`boolean` `getResizable()` Gets the resizable attribute.
`java.lang.String` `getToolTipText()` Returns the receiver's tool tip text, or null if it has not been set.
`int` `getWidth()` Gets the width of the receiver.
`void` `pack()` Causes the receiver to be resized to its preferred size.
`void` `removeControlListener(ControlListener listener)` Removes the listener from the collection of listeners who will be notified when the control is moved or resized.
`void` `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the control is selected by the user.
`void` `setAlignment(int alignment)` Controls how text and images will be displayed in the receiver.
`void` `setData(java.lang.String key, java.lang.Object value)` Sets the application defined property of the receiver with the specified name to the given value.
`void` `setImage(Image image)` Sets the receiver's image to the argument, which may be null indicating that no image should be displayed.
`void` `setMoveable(boolean moveable)` Sets the moveable attribute.
`void` `setResizable(boolean value)` Sets the resizable attribute.
`void` `setText(java.lang.String value)` Sets the receiver's text.
`void` `setToolTipText(java.lang.String toolTipText)` Sets the receiver's tool tip text to the argument, which may be null indicating that no tool tip text should be shown.
`void` `setWidth(int value)` Sets the width of the receiver.

### Methods inherited from class org.eclipse.swt.widgets.Item

`getImage, getText`

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, reskin, setData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### TreeColumn

    public TreeColumn(Tree parent,
              int style)

Constructs a new instance of this class given its parent (which must be a `Tree`) and a style value describing its behavior and appearance. The item is added to the end of the items maintained by its parent.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.LEFT`, `SWT.RIGHT`, `SWT.CENTER`, `Widget.checkSubclass()`, `Widget.getStyle()`

#### TreeColumn

    public TreeColumn(Tree parent,
              int style,
              int index)

Constructs a new instance of this class given its parent (which must be a `Tree`), a style value describing its behavior and appearance, and the index at which to place it in the items maintained by its parent.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
  `index` - the zero-relative index to store the receiver in its parent
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the parent (inclusive)
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.LEFT`, `SWT.RIGHT`, `SWT.CENTER`, `Widget.checkSubclass()`, `Widget.getStyle()`

### Method Detail

#### addControlListener

    public void addControlListener(ControlListener listener)

Adds the listener to the collection of listeners who will be notified when the control is moved or resized, by sending it one of the messages defined in the `ControlListener` interface.

Parameters:
  `listener` - the listener which should be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `ControlListener`, `removeControlListener(org.eclipse.swt.events.ControlListener)`

#### removeControlListener

    public void removeControlListener(ControlListener listener)

Removes the listener from the collection of listeners who will be notified when the control is moved or resized.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `ControlListener`, `addControlListener(org.eclipse.swt.events.ControlListener)`

#### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

Adds the listener to the collection of listeners who will be notified when the control is selected by the user, by sending it one of the messages defined in the `SelectionListener` interface.

`widgetSelected` is called when the column header is selected. `widgetDefaultSelected` is not called.

Parameters:
  `listener` - the listener which should be notified when the control is selected by the user
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

#### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

Removes the listener from the collection of listeners who will be notified when the control is selected by the user.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

#### getAlignment

    public int getAlignment()

Returns a value which describes the position of the text or image in the receiver. The value will be one of `LEFT`, `RIGHT` or `CENTER`.

Returns:
  the alignment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getMoveable

    public boolean getMoveable()

Gets the moveable attribute. A column that is not moveable cannot be reordered by the user by dragging the header but may be reordered by the programmer.

Returns:
  the moveable attribute
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `Tree.getColumnOrder()`, `Tree.setColumnOrder(int[])`, `setMoveable(boolean)`, `SWT.Move`

#### getParent

    public Tree getParent()

Returns the receiver's parent, which must be a `Tree`.

Returns:
  the receiver's parent
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getResizable

    public boolean getResizable()

Gets the resizable attribute. A column that is not resizable cannot be dragged by the user but may be resized by the programmer.

Returns:
  the resizable attribute
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getToolTipText

    public java.lang.String getToolTipText()

Returns the receiver's tool tip text, or null if it has not been set.

Returns:
  the receiver's tool tip text
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getWidth

    public int getWidth()

Gets the width of the receiver.

Returns:
  the width
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### pack

    public void pack()

Causes the receiver to be resized to its preferred size. For a composite, this involves computing the preferred size from its layout, if there is one.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setAlignment

    public void setAlignment(int alignment)

Controls how text and images will be displayed in the receiver. The argument should be one of `LEFT`, `RIGHT` or `CENTER`.

Parameters:
  `alignment` - the new alignment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setMoveable

    public void setMoveable(boolean moveable)

Sets the moveable attribute. A column that is moveable can be reordered by the user by dragging the header. A column that is not moveable cannot be dragged by the user but may be reordered by the programmer.

Parameters:
  `moveable` - the moveable attribute
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `Tree.setColumnOrder(int[])`, `Tree.getColumnOrder()`, `getMoveable()`, `SWT.Move`

#### setResizable

    public void setResizable(boolean value)

Sets the resizable attribute. A column that is not resizable cannot be dragged by the user but may be resized by the programmer.

Parameters:
  `value` - the resize attribute
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setText

    public void setText(java.lang.String value)

Description copied from class: `Item`
Sets the receiver's text.

Overrides:
  `setText` in class `Item`
Parameters:
  `value` - the new text

#### setToolTipText

    public void setToolTipText(java.lang.String toolTipText)

Sets the receiver's tool tip text to the argument, which may be null indicating that no tool tip text should be shown.

Parameters:
  `toolTipText` - the new tool tip text (or null)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setWidth

    public void setWidth(int value)

Sets the width of the receiver.

Parameters:
  `value` - the new width
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getAdapter

    public <T> T getAdapter(java.lang.Class<T> adapter)

Description copied from class: `Widget`
Implementation of the `Adaptable` interface.

IMPORTANT: This method is not part of the RWT public API. It is marked public only so that it can be shared within the packages provided by RWT. It should never be accessed from application code.

Specified by:
  `getAdapter` in interface `Adaptable`
Overrides:
  `getAdapter` in class `Widget`
Parameters:
  `adapter` - the lookup class
Returns:
  an object that can be cast to the given class or `null` if there is no adapter associated with the given class.

#### setImage

    public void setImage(Image image)

Description copied from class: `Item`
Sets the receiver's image to the argument, which may be null indicating that no image should be displayed.

Overrides:
  `setImage` in class `Item`
Parameters:
  `image` - the image to display on the receiver (may be null)

#### setData

    public void setData(java.lang.String key,
               java.lang.Object value)

Description copied from class: `Widget`
Sets the application defined property of the receiver with the specified name to the given value.

Applications may associate arbitrary objects with the receiver in this fashion. If the objects stored in the properties need to be notified when the widget is disposed of, it is the application's responsibility to hook the Dispose event on the widget and do so.

Overrides:
  `setData` in class `Widget`
Parameters:
  `key` - the name of the property
  `value` - the new value for the property
See Also:
  `Widget.getData(String)`

Copyright (c) EclipseSource and others 2002, 2019. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0